--[[Concept - extremely simple bars - one for Morale and one for Power. Just nice simple bars.]]--
																						
import "Turbine.UI"
import "Turbine.Gameplay"
import "JackdawPlugins.VBar.Class"
import "Deusdictum.UI.Dragbar"

	Player = Turbine.Gameplay.LocalPlayer.GetInstance();

	--Callback handler - Due to Pengoros... Many thanks!
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

local Load=Turbine.PluginData.Load( Turbine.DataScope.Character, "VBar" )

if Load==nil then
	Load={
	[1.000000] = 
	{
		["Data"] = 
		{
			["y"] = 160.000000,
			["x"] = 496.000000,
			["sy"] = 15.000000,
			["sx"] = 455.000000,
			["Orient"] = "l",
			["name"] = "Morale",
			["BorderWidth"] = 1.000000,
			["Fill"] = 1.000000
		}
	},
	[2.000000] = 
	{
		["Data"] = 
		{
			["y"] = 176.000000,
			["x"] = 496.000000,
			["sy"] = 5.000000,
			["sx"] = 455.000000,
			["Orient"] = "l",
			["name"] = "Power",
			["BorderWidth"] = 1.000000,
			["Fill"] = 1.000000
		}
		}
		}

end

Option=Load[3]

if Option==nil then
	Option=
	{
		["Scale"]=1,
		["X"]=100,
		["Y"]=100,
		["Opacity"]=0.75,
		["shown"]=false
	}
end

if Option.Opacity==nil then Option.Opacity=1 end
if Option.Font==nil then Option.Font="TrajanPro20" end

Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, Option.shown )

	import "JackdawPlugins.VBar.Button"

	Morale=Bar()	Power=Bar()
	
	Morale:SetSize(Load[1].Data.sx,Load[1].Data.sy)
	Morale:SetPosition(Load[1].Data.x,Load[1].Data.y)
	Morale:Orient(Load[1].Data.Orient)

	Power:SetSize(Load[2].Data.sx,Load[2].Data.sy)
	Power:SetPosition(Load[2].Data.x,Load[2].Data.y)
	Power:Orient(Load[2].Data.Orient)

	Morale:SetName("Morale")
	Morale:SetBorderColor(Turbine.UI.Color(1,0.5,0.5,0.5))
	Morale:SetBorderWidth(1)
	Morale:SetBackgroundColor(Turbine.UI.Color(0.5,0,0,0))
	Morale:SetBarColor(Turbine.UI.Color(1,0,1,0))
	
	Power:SetName("Power")
	Power:SetBorderColor(Turbine.UI.Color(1,0.5,0.5,0.5))
	Power:SetBorderWidth(1)
	Power:SetBackgroundColor(Turbine.UI.Color(0.5,0,0,0))
	Power:SetBarColor(Turbine.UI.Color(1,0,0,1))
	

Plugins["VBar"].Unload = function( sender, args )
	Morale:GetPosition()
	Power:GetPosition()
	Turbine.PluginData.Save( Turbine.DataScope.Character, "VBar", {Morale,Power,Option} )
end

Morale:SetFill(Player:GetMorale()/Player:GetMaxMorale())
Power:SetFill(Player:GetPower()/Player:GetMaxPower()) 

function MoraleChanged()
		local maxm=math.floor (Player:GetMaxMorale())
		local curm=math.floor (Player:GetMorale())
		local fract=curm/maxm
		
		Morale:SetFill(fract) 
		Morale:SetBarColor(Turbine.UI.Color(1,1-fract,fract,0))
		
		Morale:SetFill(curm/maxm) 		
		if Option.mtxt then Morale:SetText(curm.."/"..maxm) end
		if Option.mper then Morale:SetText(math.floor(curm/maxm*100) .."%") end
end

function PowerChanged()
		local maxp=math.floor (Player:GetMaxPower())
		local curp=math.floor (Player:GetPower())
		
		Power:SetFill(curp/maxp)
		
		if Option.ptxt then Power:SetText(curp.."/"..maxp) end
		if Option.pper then Power:SetText(math.floor(curp/maxp*100) .."%") end
end
	
--Callbacks when Morale or Power changes.
AddCallback(Player,"MoraleChanged", function(sender, args) 	MoraleChanged() end)
AddCallback(Player,"PowerChanged", function(sender, args) PowerChanged() end)

--Add a callbacks if the players maximum morale/power changes.
AddCallback(Player, "BaseMaxMoraleChanged", function(sender, args) MoraleChanged() end)
AddCallback(Player, "BaseMaxPowerChanged", function(sender, args)	PowerChanged() end)

MoraleChanged() PowerChanged()

--Watch for the UI being unlocked, this will then make all the controls fill to 80% and Mouse-visible.

Morale.Window.DragEnable= function()
			Morale:SetFill(0.8)
			Power:SetFill(0.8) 
			Morale:SetOpacity(1)
			Power:SetOpacity(1)
			Morale:SetMouseVisible(true)
			Power:SetMouseVisible(true)
		end
Morale.Window.DragDisable= function ()
			Morale:SetFill(Player:GetMorale()/Player:GetMaxMorale())
			Power:SetFill(Player:GetPower()/Player:GetMaxPower()) 
			Morale:SetMouseVisible(false)
			Power:SetMouseVisible(false)
		end
		
		
function split(s)
	--splits a string, wherever it finds a " "
	local result
	local i
	
	p=0
	result={}
	
	while string.len(s)>0 do
	
		i=string.find(s," ")
		if i~=nil then
			p=p+1
			result[p]=string.sub(s, 1, i-1)
			s=string.sub(s,i+1)
		else
			--No spaces found, make the string null.
			p=p+1
			result[p]=s
			s=""
		end
	
	end
		
	return result
end

--Shell Commands
shellCommand = Turbine.ShellCommand()
function shellCommand:Execute(command, i)

	i=string.lower(i)

	i=split(i)

	
	if i[1]=="test" then
		local fract=tonumber(i[2])or 1
		Morale:SetFill(fract)
		Morale:SetBarColor(Turbine.UI.Color(1,1-fract,fract,0))
		Power:SetFill(fract)
	elseif i[1]=="msize" then
		if i[2]==nil then
			Turbine.Shell.WriteLine("Current size "..Morale.Window:GetWidth()..","..Morale.Window:GetHeight())
		else
			local x=tonumber(i[2])
			local y=tonumber(i[3])
			Morale:SetSize(x,y)
			MoraleChanged()
		end
	elseif i[1]=="mposition" then
		if i[2]==nil then
			Turbine.Shell.WriteLine("Current position "..Morale.Window:GetLeft()..","..Morale.Window:GetTop())
		else
			local x=tonumber(i[2])
			local y=tonumber(i[3])
			Morale:SetPosition(x,y)
		end
	elseif i[1]=="psize" then
		if i[2]==nil then
			Turbine.Shell.WriteLine("Current size "..Power.Window:GetWidth()..","..Power.Window:GetHeight())
		else
			local x=tonumber(i[2])
			local y=tonumber(i[3])
			Power:SetSize(x,y)
		end
	elseif i[1]=="pposition" then
		if i[2]==nil then
			Turbine.Shell.WriteLine("Current position "..Power.Window:GetLeft()..","..Power.Window:GetTop())
		else
			local x=tonumber(i[2])
			local y=tonumber(i[3])
			Power:SetPosition(x,y)
		end
	else	
		Turbine.Shell.WriteLine("Slash commands for Vbar;")
		Turbine.Shell.WriteLine("'/vb test n' where n is a number between 0 and 1. Test bar at that fill level")
		Turbine.Shell.WriteLine("'/vb msize x y' sets the Morale bar to size x,y. Without x or y gives current size")
		Turbine.Shell.WriteLine("'/vb psize x y' sets the Power bar to size x,y. Without x or y gives current size")
		Turbine.Shell.WriteLine("'/vb mposition x y' sets the Morale bar to position x,y. Without x or y gives current position")
		Turbine.Shell.WriteLine("'/vb pposition x y' sets the Power bar to position x,y. Without x or y gives current position")
	end
end
Turbine.Shell.AddCommand('VB', shellCommand)